%Chapt1Fig12.m
%classical sho diatomic linear chain dispersion;
clear;
clf;

kappa=1;								%spring constant
m1=1.0;									%mass of particle 1  1.0
m2=0.5;									%mass of particle 2  0.5
ymax=(2*kappa*(m1+m2)/(m1*m2))^0.5;		%maximum frequency

x=[-pi:.01:pi];							%wave vector [start:increment:stop]   
a=1.0;
b=2.0*kappa*(m1+m2)/(m1*m2);
c=2.0*kappa*kappa*(1-cos(x))/(m1*m2);
y21tmp=(b.*b-4.*a.*c).^.5;
y21=(-b+y21tmp)/(2*a);
y21=(abs(y21)).^0.5;
y22=(-b-y21tmp)/(2*a);
y22=(abs(y22)).^0.5;

figure(1);
hold on;
plot(x,y21,'b');						%the acoustic branch
plot(x,y22,'r');						%the optical branch
axis([-pi,pi,0,1.1*ymax]);
temp2=['Chapt1Fig10, \kappa = ',num2str(kappa),', m_1 = ',...
    num2str(m1),', m_2 = ',num2str(m2)];
title(temp2);
xlabel(['Wave vector, q']);
ylabel(['Frequency,  \omega(q)']);
hold off;

