%Chapt4Exercise7a.m
%transmission through asymmetric double barrier at fixed voltage bias
clear
clf;
dL=1e-10;					%increment in distance (m)
N=130;						%number of samples of potential
V(1:N)=0; V(11:51)=0.5; V(89:119)=1.13;  %potential without voltage bias
f(1:10)=0; 
Vbias=-0.63;								%voltage bias (eV)
for x=11:119, f(x)=(x-11)*Vbias/108;end,	%add voltage bias to potential 

f(120:130)=Vbias;
   V=V+f;
   
Emin=(pi*1e-5)+Vbias;	%add (pi*1.0e-5) to energy to avoid divide by zero
Emax=1.3;				%maximum particle energy (eV)
npoints=1000;			%number of points in energy plot				
dE=(Emax-Emin)/npoints;	%energy increment (eV)
hbar=1.0545715e-34;		%Planck's constant (J s)
eye=complex(0.,1.);		%square root -1
m0=9.109382e-31;		%bare electron mass (kg)
meff=0.07;				%effective electron mass / m0
m=meff*m0;				%effective electron mass (kg)
echarge=1.6021764e-19;	%electron charge (C)

for j=1:npoints
   E(j)=dE*j+Emin;
   bigP=[1,0;0,1];		%default value of matrix bigP
      for i=1:N
         k(i)=sqrt(2*echarge*m*(E(j)-V(i)))/hbar;
      end
      for n=1:(N-1)
         p(1,1)=0.5*(1+k(n+1)/k(n))*exp(-eye*k(n)*dL);
         p(1,2)=0.5*(1-k(n+1)/k(n))*exp(-eye*k(n)*dL);
         p(2,1)=0.5*(1-k(n+1)/k(n))*exp(eye*k(n)*dL);
         p(2,2)=0.5*(1+k(n+1)/k(n))*exp(eye*k(n)*dL);
         bigP=bigP*p;
      end
      Trans(j)=(abs(1/bigP(1,1)))^2;
   end
   
figure(1);
subplot(1,2,1),plot(0.1:0.1:13,V),axis([0,13,Emin,Emax]);
xlabel('Position, x (nm)'),ylabel('Potential energy, V (eV)');
ttl=['Chapt4Exercise7a, m_{eff} = ',num2str(meff),...
    ', V_{bias} = ',num2str(Vbias)];
title(ttl);
subplot(1,2,2),plot(Trans,E),axis([0,1,Emin,Emax]);
xlabel('Trans. coeff.'),ylabel('Energy, E (eV)');

figure(2);
subplot(1,2,1),plot(0.1:0.1:13,V),axis([0,13,Emin,Emax]);
xlabel('Position, x (nm)'),ylabel('Potential energy, V(eV)');
title(ttl);
subplot(1,2,2),plot(-log(Trans),E),axis([0,30,Emin,Emax]);
xlabel('-ln (Trans. coeff.)'),ylabel('Energy, E (eV)');
