%Chapt4Exercise8.m
%eigenstates of resonant tunner barrier
%
clear
clf;
length = 5;					%length of well (nm)
N=1000;						%number of sample points
x=0:length/N:length;		%position of sample points in potential
mass=1.00;					%effective electron mass
num_sol=2;					%number of solutions sought
v0=1;						%potential scale (eV)

 v=v0.*ones(1,N+1);
 
% first well
 for i=341:460				%well width 120*length/N   = 0.6 nm
    v(i)=0;
 end
							%barrier width 81*length/N = 0.4 nm
% second well
 for i=540:659				%well width 120*length/N   = 0.6 nm

    v(i)=0;
 end


[energy,phi]=solve_schM(length,N,v,mass,num_sol); %call function solve_schM
   
   for i=1:num_sol
sprintf(['eigenfunction (',num2str(i),') = ',...
    num2str(energy(i)),' eV'])	%energy eigenvalues
   end
     
figure(1);
 plot(x,v,'b');
 xlabel('Position, x (nm)'),ylabel('Potential energy, V (eV)');
 axis([ 0 x(end) 0 1.1*max(v) ]);
 ttl=['Chapt4Exercise8, m* = ',num2str(mass),'m_0, Length = ',...
     num2str(length),'nm'];
 title(ttl);

s=char('y','k','r','g','b','m','c');	%plot curves in different colors

figure(2);
for i=1:num_sol
   j=1+mod(i,7);						%select color for plot
   	plot(x,phi(:,i),s(j));				%plot eigenfunctions
     hold on;
  end
 xlabel('Position, x (nm)'),ylabel('Wave function, \psi(x)');
 title(ttl);
hold off;