%Chapt4Exercise9.m
%a finite periodic potential
%
clear
clf;
length = 100;				%length of well (nm)
N=400;						%number of sample points
x=0:length/N:length;		%position of sample points in potential
mass=0.07;					%effective electron mass
num_sol=3;					%number of solutions sought
v0=1.0;						%potential scale (eV)

v=ones(1,N+1);

for i=50:40:N-50			%potential (eV)
   for j=1:25
      v(i+j)=0.0;
   end
   end

[energy,phi]=solve_schM(length,N,v,mass,num_sol);%call function solve_schM

%energy eigenvalues  
   for i=1:num_sol
sprintf(['eigenfunction (',num2str(i),') = ',num2str(energy(i)),' eV'])	
     end
     
figure(1);
plot(x,v,'b');
xlabel('Position, x (nm)'),ylabel('Potential energy, V (eV)');
axis([ 0 x(end) 0 1.1*max(v) ]);
ttl=['Chapt4Exercise9, m* = ',num2str(mass),'m_0, Length = ',...
    num2str(length),'nm'];
title(ttl);
s=char('y','k','r','g','b','m','c');	%plot curves in different colors

figure(2);
for i=1:num_sol
   j=1+mod(i,7);						%select color for plot
   	plot(x,phi(:,i),s(j));				%plot eigenfunctions
     hold on;
  end
xlabel('Position, x (nm)'),ylabel('Wave function, \psi(x)');
title(ttl);
hold off;