function Lnl = Laguerre(nn,LL,ro)
% calculate the Laguerre Polynomial value corresponding
% to given n,l and x values
% Inputs:
%        nn, LL, ro=r/aB
% Output:
%        Lnl

fnL = factorial(nn+LL); %(nn+LL)!
mmax=nn-LL-1;
Lnl = 0.0;  % the Laguerre polynomial result
for mL=0:mmax;
    tmp = (-1)^(mL+(2*LL)+1);
    fnm = factorial(nn-LL-1-mL); %(nL-mL)!
    fkm = factorial((2*LL)+1+mL); %(kL+mL)!
    fm = factorial(mL);     %mL!
    tmp = (tmp*fnL*fnL)/(fnm*fkm*fm);
    tmp = tmp*(ro^mL);
    Lnl = Lnl+ tmp;
end

